
#include "headers.h"

ToFree _toFree;

int AddIn_main(int isAppli, unsigned short OptionNum)
{
    int locX = 0, locY = 0, curX = 0, curY = 0, maxRowsScreen = 8, displayMode = 0, caps = 1, size = 0, displayLines = 1, errorCur = 0, cur = 0;
    unsigned int key = 0;
    int i = 0, j = 0;
    int totalFiles = 0, *fileSize = NULL, fileSelected = 0, newFile = 0;
    char **path = NULL, *buffer = NULL, displayErrors = 0, *rnd = NULL;
    BuildError errors;
    Edit edited = {NULL, NULL, NULL, 0, 0};

    if (!initErrors(&errors, 1))
        return 0;
    else
        SetQuitHandler((void*)epilogue);

    _toFree.edited = &edited;
    _toFree.errors = &errors;
    _toFree.filePath = &path;
    _toFree.fileSize = &fileSize;
    _toFree.totalFiles = &totalFiles;

    path = loadFileIndex(&totalFiles, &fileSize);
    fileSelected = selectFile(&path, &totalFiles, &fileSize, -1, edited);
    if (fileSelected<0)
        return 1;

    openFile(&edited, path[fileSelected]);

    while(1)
    {
        switch(key)
        {
        case KEY_CTRL_UP:
            curY--;
            if (curY<0)
            {
                curY = 0;
                curX = 0;
            }
            else
                if (curX>edited.length[curY])
                    curX = edited.length[curY];
            break;
        case KEY_CTRL_DOWN:
            curY++;
            if (curY>=edited.rows)
            {
                curY = edited.rows-1;
                curX = edited.length[curY];
            }
            else
                if (curX>edited.length[curY])
                    curX = edited.length[curY];
            break;
        case KEY_CTRL_RIGHT:
            curX++;
            if (curX>edited.length[curY])
            {
                if (curY<edited.rows-1)
                {
                    curX = 0;
                    curY++;
                }
                else
                    curX = edited.length[curY];
            }
            break;
        case KEY_CTRL_LEFT:
            curX--;
            if (curX<0)
            {
                if (curY>0)
                {
                    curY--;
                    curX = edited.length[curY];
                }
                else
                    curX = 0;
            }
            break;
        default:
            break;
        }

        if (curY<=locY && curY>0)
            locY = curY-1;
        if (curY>=locY+maxRowsScreen-1)
            locY = curY-maxRowsScreen+2;
        if (curX<=locX)
            locX = curX-1;
        if (curX-locX>(20-displayLines*3))
                locX = curX-(20-displayLines*3);
        if (locX<0)
            locX = 0;

        if (key==KEY_CTRL_F5)
            caps = !caps;

        if ((key>=KEY_CHAR_A && key<=KEY_CHAR_Z) || (key>=KEY_CHAR_0 && key<=KEY_CHAR_9) || key==KEY_CHAR_DP || key==KEY_CHAR_MINUS || key==KEY_CHAR_PLUS || key==KEY_CHAR_MULT || key==KEY_CHAR_DIV || key==KEY_CHAR_SPACE || key==KEY_CHAR_EXP || key==KEY_CHAR_COMMA || key==KEY_CHAR_LBRCKT || key==KEY_CHAR_RBRCKT || key==KEY_CHAR_LBRACE || key==KEY_CHAR_RBRACE || key==KEY_CHAR_LPAR || key==KEY_CHAR_RPAR || key==KEY_CHAR_PMINUS || key==KEY_CHAR_FRAC)
        {
            edited.length[curY]++;
            if (edited.alloc[curY]<=(edited.length[curY]+1))
            {
                edited.alloc[curY] = upperInt(edited.length[curY]+1, ALLOC_COLUMN);
                edited.base[curY] = (char*)realloc(edited.base[curY], edited.alloc[curY]);
            }

            for (i=edited.length[curY];i>curX;i--)
                edited.base[curY][i] = edited.base[curY][i-1];

            if (key>=KEY_CHAR_A && key<=KEY_CHAR_Z)
                edited.base[curY][curX] = key+32*caps;
            else
                if (key>=KEY_CHAR_0 && key<=KEY_CHAR_9)
                    edited.base[curY][curX] = key;
            else
                if (key==KEY_CHAR_DP)
                    edited.base[curY][curX] = '.';
            else
                if (key==KEY_CHAR_COMMA)
                    edited.base[curY][curX] = ',';
            else
                if (key==KEY_CHAR_MINUS)
                    edited.base[curY][curX] = '-';
            else
                if (key==KEY_CHAR_PLUS)
                    edited.base[curY][curX] = '+';
            else
                if (key==KEY_CHAR_DIV)
                    edited.base[curY][curX] = '/';
            else
                if (key==KEY_CHAR_MULT)
                    edited.base[curY][curX] = '*';
            else
                if (key==KEY_CHAR_SPACE)
                    edited.base[curY][curX] = ' ';
            else
                if (key==KEY_CHAR_EXP)
                    edited.base[curY][curX] = ':';
            else
                if (key==KEY_CHAR_LBRCKT)
                    edited.base[curY][curX] = '[';
            else
                if (key==KEY_CHAR_RBRCKT)
                    edited.base[curY][curX] = ']';
            else
                if (key==KEY_CHAR_LBRACE)
                    edited.base[curY][curX] = '{';
            else
                if (key==KEY_CHAR_RBRACE)
                    edited.base[curY][curX] = '}';
            else
                if (key==KEY_CHAR_LPAR)
                    edited.base[curY][curX] = '(';
            else
                if (key==KEY_CHAR_RPAR)
                    edited.base[curY][curX] = ')';
            else
                if (key==KEY_CHAR_PMINUS)
                    edited.base[curY][curX] = '_';
            else
                if (key==KEY_CHAR_FRAC)
                    edited.base[curY][curX] = '@';

            curX++;
            if (curX-locX>(20-displayLines*3))
                locX = curX-(20-displayLines*3);
        }

        if (key==KEY_CTRL_EXE)
        {
            edited.rows++;

            if (edited.rows>edited.rowsAlloc)
            {
                edited.rowsAlloc = upperInt(edited.rows+1, ALLOC_ROW);
                edited.base = (char**)realloc(edited.base, edited.rowsAlloc*sizeof(char*));
                edited.length = (int*)realloc(edited.length, edited.rowsAlloc*sizeof(int));
                edited.alloc = (int*)realloc(edited.alloc, edited.rowsAlloc*sizeof(int));
            }

            size = edited.length[curY]-curX;
            buffer = NULL;

            buffer = (char*)malloc(size);
            for (i=0;i<size;i++)
                buffer[i] = edited.base[curY][curX+i];

            edited.base[curY][curX] = 0;
            edited.length[curY] = curX;

            curY++;
            if (curY>=locY+maxRowsScreen-1)
                locY = curY-maxRowsScreen+2;

            for (i=edited.rows-1;i>curY;i--)
            {
                edited.base[i] = edited.base[i-1];
                edited.length[i] = edited.length[i-1];
                edited.alloc[i] = edited.alloc[i-1];
            }

            edited.length[i] = size;

            if (size>0)
            {
                edited.alloc[i] = upperInt(edited.length[i]+1, ALLOC_COLUMN);
                edited.base[i] = (char*)calloc(edited.alloc[i], 1);
            }
            else
            {
                edited.alloc[i] = 1;
                edited.base[i] = (char*)calloc(edited.alloc[i], 1);
            }

            for (j=0;j<size;j++)
                edited.base[i][j] = buffer[j];

            free(buffer);

            curX = 0;
        }

        if (key==KEY_CTRL_DEL)
        {
            if (curX>0)
            {
                for (i=curX-1;i<edited.length[curY]+1;i++)
                    edited.base[curY][i] = edited.base[curY][i+1];

                edited.length[curY]--;
                curX--;
            }
            else if (curY>0)
            {
                curX = edited.length[curY-1];
                blendRowUp(edited.base, edited.length, edited.alloc, &curY, &edited.rows);
            }

            if (curY<=locY && curY>0)
                locY = curY-1;
        }

        if (key==KEY_CTRL_OPTN)
        {
            displayMode = !displayMode;
            maxRowsScreen = 8 + 3*(displayMode);
        }

        if(key==KEY_CHAR_SQUARE)
            displayLines = !displayLines;

        if (key==KEY_CTRL_EXIT)
        {
            newFile = selectFile(&path, &totalFiles, &fileSize, fileSelected, edited);
            if (newFile==-2)
                break;
            if (newFile==-1)
            {
                if (doSave(path[fileSelected], 0))
                    saveFile(edited, path[fileSelected]);
                break;
            }
            if (newFile!=fileSelected)
            {
                if (doSave(path[fileSelected], 0))
                {
                    saveFile(edited, path[fileSelected]);
                    updateFileSize(fileSize, path, fileSelected);
                }
                fileSelected = newFile;
                openFile(&edited, path[fileSelected]);

                flushErrors(&errors);
                errors.number = -1;

                curX = 0;
                curY = 0;
                locX = 0;
                locY = 0;
            }
        }
        if(key==KEY_CTRL_F1)
            if (doSave(path[fileSelected], 0))
            {
                saveFile(edited, path[fileSelected]);
                updateFileSize(fileSize, path, fileSelected);
            }

        if (key==KEY_CTRL_F2)
        {
            flushErrors(&errors);
            if (assembler(&edited, &errors, path[fileSelected]))
                openFile(&edited, path[fileSelected]);

            displayErrors = 1;
        }

        if (key==KEY_CTRL_F3)
        {
            if (errorSearch(&errors, &errorCur)!=-1)
            {
                curY = errors.errors[errorCur].line;
                curX = 0;

                if (curY<=locY && curY>0)
                    locY = curY-1;
                if (curY>=locY+maxRowsScreen-1)
                    locY = curY-maxRowsScreen+2;
            }
        }

        ML_clear_vram();

        displayRows(edited.base, edited.length, edited.rows, locX, locY, displayMode, displayLines);
        if (!displayMode)
        {
            ML_vertical_line((curX-locX)*6+displayLines*18, (curY-locY)*8, (curY-locY)*8+6, ML_XOR);
            ML_vertical_line((curX-locX)*6+1+displayLines*18, (curY-locY)*8, (curY-locY)*8+6, ML_XOR);
        }
        else
            ML_vertical_line((curX-locX)*5+displayLines*18, (curY-locY)*6, (curY-locY)*6+4, ML_XOR);

        if (displayErrors)
        {
            displayErrorsNumberHint(errors.number);
            displayErrors = 0;
        }

        locate(19, 8);
        if (caps==1)
            PrintRev((unsigned char*)"lwr");
        else
            PrintRev((unsigned char*)"UPR");

        ML_display_vram();
        GetKey(&key);
    }

    return 1;
}

int upperInt (int value, int gap)
{
    value-=value%gap;
    value+=gap;

    return value;
}

void displayRows(char **base, int *length, int rows, int locX, int locY, int mode, int displayLines)
{
    int i = 0, offsetX = 0, len = 0;
    char buffer[10];

    switch(mode)
    {
    case 0:
        if (displayLines)
        {
            for (i=0;i<8;i++)
            {
                sprintf(buffer, "%d\0", i+locY);
                len = strlen(buffer);
                PrintMini(4*(4-len), i*8+1, (unsigned char*)buffer, 0);
            }
            ML_rectangle(0, 0, 15, 63, 0, ML_BLACK, ML_XOR);
            offsetX = 3;
        }

        for (i=0;i<8;i++)
        {
            if (locY+i>=rows)
                break;

            if (locX<length[locY+i])
            {
                locate(1+offsetX, i+1);
                Print((unsigned char*)base[locY+i]+locX);
            }
        }
        break;
    case 1:
        if (displayLines)
        {
            for (i=0;i<11;i++)
            {
                sprintf(buffer, "%d\0", i+locY);
                len = strlen(buffer);
                PrintMini(4*(4-len), i*6+1, (unsigned char*)buffer, 0);
            }
            ML_rectangle(0, 0, 15, 63, 0, ML_BLACK, ML_XOR);
            offsetX = 18;
        }

        for (i=0;i<11;i++)
        {
            if (locY+i>=rows)
                break;

            if (locX<length[locY+i])
                PrintMiniReg(offsetX, i*6, base[locY+i]+locX, 0);
        }
        break;
    default:
        break;
    }
}

void blendRowUp (char **base, int *length, int *alloc, int *curY, int *rows)
{
    int i = 0, lengthString = 0, offset = 0, cury = *curY;
    char *buffer = NULL;

    lengthString = length[cury] + 1;
    buffer = (char*)malloc(lengthString);

    for (i=0;i<lengthString;i++)
        buffer[i] = base[cury][i];

    free(base[cury]);

    offset = length[cury-1];
    length[cury-1] += (lengthString-1);
    alloc[cury-1] = upperInt(length[cury-1] + 1, ALLOC_COLUMN);
    base[cury-1] = (char*)realloc(base[cury-1], alloc[cury-1]);

    for (i=0;i<lengthString;i++)
        base[cury-1][offset+i] = buffer[i];

    *rows = (*rows)-1;
    *curY = (*curY)-1;

    for (i=cury;i<(*rows);i++)
    {
        base[i] = base[i+1];
        length[i] = length[i+1];
        alloc[i] = alloc[i+1];
    }

    free(buffer);
}
int errorSearch (BuildError *errors, int *curOri)
{
    int cur = *curOri, i = 0, j = 0, max = errors->number, curX = 0, cam = 0, len = 0;
    char buffer[300];
    unsigned int key = 0;

    if (cur<=cam)
    {
        cam = cur-1;
        if (cam<0)
            cam = 0;
    }
    if (cur>cam+7)
        cam = cur-6;

    if (max>0)
        len = strlen(errors->messages[errors->errors[cur].type]) + strlen(errors->errors[cur].lineStr);

    while(1)
    {
        if (key==KEY_CTRL_EXIT || key==KEY_CTRL_F3)
        {
            cur = -1;
            break;
        }
        if (key==KEY_CTRL_EXE)
        {
            if (max>0)
                *curOri = cur;
            else
                cur = -1;
            break;
        }
        if (key==KEY_CTRL_UP)
        {
            cur--;
            if (cur<0)
                cur = 0;
            if (max>0)
                len = strlen(errors->messages[errors->errors[cur].type]) + strlen(errors->errors[cur].lineStr);

            if (cur<cam+1)
                cam = cur-1;
            if (cam<0)
                cam = 0;
        }
        if (key==KEY_CTRL_DOWN)
        {
            cur++;
            curX = 0;
            if (cur>=max)
                if (max!=0)
                    cur = max-1;
                else
                    cur = 0;
            if (cur>cam+6 && cur<(max-1))
                cam = cur-6;

            if (max>0)
                len = strlen(errors->messages[errors->errors[cur].type]) + strlen(errors->errors[cur].lineStr);
        }
        if (key==KEY_CTRL_LEFT)
        {
            curX-=ERROR_SELECT_X_STEP;;
            if (curX<0)
                curX = 0;
        }
        if (key==KEY_CTRL_RIGHT)
        {
            curX+=ERROR_SELECT_X_STEP;

            if (curX>(len-21))
                curX = len-21;
            if (curX<0)
                curX = 0;
        }

        ML_clear_vram();

        if (max>0)
        {
            for (i=0;i<8 && i+cam<max;i++)
            {
                strcpy(buffer, errors->errors[i+cam].lineStr);
                for (j=0;buffer[j]!=0;j++);
                strcpy(buffer+j, errors->messages[errors->errors[i+cam].type]);
                if (curX<strlen(buffer))
                {
                    locate(1, i+1);
                    if (i+cam==cur)
                        PrintRev((unsigned char*)buffer+curX);
                    else
                        Print((unsigned char*)buffer+curX);
                }
            }
        }
        else if (max==0)
        {
            locate(1, 1);
            Print((unsigned char*)"Good news m8 :\0");
            locate(1, 2);
            PrintRev((unsigned char*)"No error there !\0");
        }
        else
        {
            locate(1, 1);
            Print((unsigned char*)"No error found yet :/\0");
            locate(1, 3);
            PrintRev((unsigned char*)"Start the assembler\0");
            locate(1, 4);
            PrintRev((unsigned char*)"with [F2] !\0");
        }

        ML_display_vram();
        GetKey(&key);
    }

    return cur;
}

void displayErrorsNumberHint (int num)
{
    char *buffer = NULL, len = 0, i = 1;

    buffer = (char*)malloc(26);
    memset(buffer, ' ', 25);
    buffer[25] = 0;

    if (num>0)
    {
        i+=itoa(buffer+i, num, 0)+1;
        memcpy(buffer+i, "errors found.", 14);
        buffer[i+13] = ' ';
    }
    else
    {
        memcpy(buffer+i, "No error found !", 17);
        buffer[i+16] = ' ';
    }

    locate(1, 8);
    PrintRev((unsigned char*)buffer);

    free(buffer);
}

void PrintMiniReg (int x, int y, char *str, int type)
{
    int i = 0, xBuf = 0;
    char buf[2] = {0};

    for (i=0;str[i]!=0;i++)
    {
        buf[0] = str[i];
        xBuf = x + i*5;
        PrintMini(xBuf, y, (unsigned char*)buf, type);
        if (xBuf>=128)
            break;
    }
}

void epilogue (void)
{
    int i = 0;

    saveFileIndex(*(_toFree.filePath), *(_toFree.totalFiles));

    for (i=0;i<_toFree.edited->rows;i++)
        free((_toFree.edited->base)[i]);

    free(_toFree.edited->alloc);
    free(_toFree.edited->length);
    free(_toFree.edited->base);
    free(*(_toFree.fileSize));

    for (i=0;i<*(_toFree.totalFiles);i++)
        free((*(_toFree.filePath))[i]);

    free(*(_toFree.filePath));

    flushErrors(_toFree.errors);

    for (i=0;i<24;i++)
        free(_toFree.errors->messages[i]);
    free(_toFree.errors->messages);
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section
