
#ifndef _ERROR_MESSAGES_H
#define _ERROR_MESSAGES_H

#include "headers.h"

typedef struct Error Error;
struct Error
{
    int line;
    char *lineStr;
    int type;
};

typedef struct BuildError BuildError;
struct BuildError
{
    Error *errors;
    int number;
    char **messages;
};

enum commonErrorsASM
{
    ARGV_MNEMO_NOT_MATCHING,
    ARGV_MISSING,
    DAT_TOO_LARGE_2NIB,
    DAT_TOO_LARGE_1NIB,
    COMMA_NO_ARGV,
    NO_FIRST_ARGV,
    NO_SECOND_ARGV,
    STACK_POP_PUSH,
    SIGN_IMM_NO_DAT,
    RANDOM_AT,
    RANDOM_AT_DISP,
    RANDOM_AT_2,
    R0_NO_ARGV,
    RANDOM_AT_DISP_RN,
    R0_RND_RN,
    RN_INVALID_SYMBOL,
    IMM_HEX_NO_DATA,
    RN_OUT_OF_BOUNDS,
    DAFUK_MNEMO,
    WTF,
    NO_ARGV,
    CMP_TYPICAL,
    LABEL_NOT_REACHEABLE,
    ERR_ASM_MAX_MESSAGES
};

int initErrors (struct BuildError *errors, int isASM);
void addError (struct BuildError* errors, int line, int type);
void flushErrors (struct BuildError* errors);

#endif // ERROR_MESSAGES_H
