
#ifndef MAIN_H
#define MAIN_H

#include "headers.h"

typedef struct Edit Edit;
struct Edit
{
    char **base;
    int *length;
    int *alloc;

    int rows;
    int rowsAlloc;
};

typedef struct ToFree ToFree;
struct ToFree
{
    Edit *edited;
    struct BuildError *errors;

    char ***filePath;
    int **fileSize;
    int *totalFiles;
};

int upperInt (int value, int gap);
void displayRows(char **base, int *length, int rows, int locX, int locY, int mode, int displayLines);
void blendRowUp (char **base, int *length, int *alloc, int *curY, int *rows);
unsigned char key_down(unsigned char code);
void epilogue (void);
int errorSearch (struct BuildError *errors, int *curOri);
void displayErrorsNumberHint (int num);
void PrintMiniReg (int x, int y, char *str, int type);

#endif // MAIN_H
